<template>
  <div>
    <Nuxt :user="user" />
  </div>
</template>

<script>
export default {
  data() {
    return {
      user: '',
    };
  },

  created() {
    this.$nuxt.$on('signout', () => {
      this.signout();
    });

    this.$fire.auth.onAuthStateChanged(user => {
      if (!user) {
        this.user = '';
        this.$router.push('/');
        return;
      }
      this.getUserFromFirestore(user.uid);
      this.$router.push(`/${user.uid}`);
    });
  },

  methods: {
    async getUserFromFirestore(uid) {
      const currentUser = this.$fire.firestore
        .collection('Users')
        .doc(uid)
      try {
        const snapshot = await currentUser.get()
        const doc = snapshot.data()
        if (!doc) {
          alert('Document does not exist.')
          return
        }
        this.user = doc;
      } catch (e) {
        alert(e)
      }
    },

    signout() {
      this.$fire.auth.signOut().then(result => {
        this.user = '';
        this.$router.push('/');
      })
    },
  },
}
</script>

<style>
html {
  font-family: 'Source Sans Pro', -apple-system, BlinkMacSystemFont, 'Segoe UI',
    Roboto, 'Helvetica Neue', Arial, sans-serif;
  font-size: 16px;
  word-spacing: 1px;
  -ms-text-size-adjust: 100%;
  -webkit-text-size-adjust: 100%;
  -moz-osx-font-smoothing: grayscale;
  -webkit-font-smoothing: antialiased;
  box-sizing: border-box;
}

body {
  color: #205072;
}

*,
*::before,
*::after {
  box-sizing: border-box;
  margin: 0;
}

.button--green {
  display: inline-block;
  border-radius: 4px;
  border: 1px solid #3b8070;
  color: #3b8070;
  text-decoration: none;
  padding: 10px 30px;
}

.button--green:hover {
  color: #fff;
  background-color: #3b8070;
}

.button--grey {
  cursor: pointer;
  display: inline-block;
  border-radius: 4px;
  border: 1px solid #35495e;
  color: #35495e;
  text-decoration: none;
  padding: 10px 30px;
  margin-left: 15px;
}

.button--grey:hover {
  color: #fff !important;
  background-color: #35495e;
}


header {
  width: 100%;
  background-color: #E0ECDE;
  padding: 2rem 1rem;
  margin-bottom: 2rem;
}

.title {
  font-family: 'Quicksand', 'Source Sans Pro', -apple-system, BlinkMacSystemFont,
    'Segoe UI', Roboto, 'Helvetica Neue', Arial, sans-serif;
  display: block;
  font-weight: 300;
  font-size: 100px;
  color: #35495e;
  letter-spacing: 1px;
}

.avatar {
  border-radius: 100% !important;
  border: 4px solid #fff;
  width: 80px;
}
</style>
